Attribute VB_Name = "basCommon"
' eNotes v.1.0.18
' Copyright (C) 2003 TheLegs
'
' These are the files of the source code of eNotes.
' For further info about eNotes and its source code,
' licensing etc. refer to the README.TXT included in
' the package.
'
' DISCLAIMER
'
' This program is free software; you can redistribute it
' and/or modify it under the terms of the GNU General
' Public License as published by the Free Software
' Foundation; either version 2 of the License, or (at
' your option) any later version.
'
' This program is distributed in the hope that it will
' be useful, but WITHOUT WARRANTY; without even the
' implied warranty of MERCHANTABILITY or FITNESS FOR A
' PARTICULAR PURPOSE. See the GNU General Public License
' for more details.
'
' You should have received a copy of the GNU General
' Public License along with this program; if not,
' write to the Free Software Foundation, Inc., 59
' Temple Place - Suite 330, Boston, MA 02111-1307, USA.
'
' E-mail the author at: enotes@tahome.cjb.net.
'
Option Explicit

' The following value can contain an higher
' value, of course. However consider that:
' a) this value indicates how much copies of
'    the frmNote object will be created.
'    Of course an higher value will mean an
'    higher wasting of resources;
' b) anyway, did you really need more than
'    50 little windows floating in your
'    screen?
'
Global Const MAXNOTES = 50

' Default values.
Global Const DEFAULTBGCOLOR = &HC0FFFF      ' Bright yellow
Global Const DEFAULTCOLOR = &H0&            ' Black
Global Const DEFAULTFONTNAME = "Comic Sans MS"
Global Const DEFAULTFONTSIZE = 9

' Colors used as background
Global Const BGCOLOR0 = &HFFFFFF        ' White
Global Const BGCOLOR1 = &HC0C0FF        ' Red
Global Const BGCOLOR2 = &HC0E0FF        ' Orange
Global Const BGCOLOR3 = &HC0FFFF        ' Yellow
Global Const BGCOLOR4 = &HC0FFFF        ' Green
Global Const BGCOLOR5 = &HFFFFC0        ' Cyan
Global Const BGCOLOR6 = &HFFC0C0        ' Violet
Global Const BGCOLOR7 = &HFFC0FF        ' Magenta

' Settings stored in registry.
Global PresetBGColor As Long
Global PresetColor As Long
Global PresetFontName As String
Global PresetFontSize As Integer
Global UsePresets As Boolean
Global UseRandomBGColor As Boolean

Global NewNote(1 To MAXNOTES) As frmNote
Global NoteCount As Long

Sub CreateNote()

    NoteCount = NoteCount + 1
    frmMain.lblStatus = StrX(NoteCount)
    
    Set NewNote(NoteCount) = New frmNote

    If UsePresets = True Then
        NewNote(NoteCount).txtNote.BackColor = IIf(UseRandomBGColor, RandomBack, PresetBGColor)
        NewNote(NoteCount).txtNote.ForeColor = PresetColor
        NewNote(NoteCount).txtNote.FontName = PresetFontName
        NewNote(NoteCount).txtNote.FontSize = PresetFontSize
    Else
        NewNote(NoteCount).txtNote.BackColor = DEFAULTBGCOLOR
        NewNote(NoteCount).txtNote.ForeColor = DEFAULTCOLOR
        NewNote(NoteCount).txtNote.FontName = DEFAULTFONTNAME
        NewNote(NoteCount).txtNote.FontSize = DEFAULTFONTSIZE
    End If
    
    NewNote(NoteCount).Show vbModeless, frmMain

End Sub

Sub Main()
    
    If App.PrevInstance = True Then _
        MsgBox "eNotes is already running.", vbInformation: End
        
    Randomize
    
    PresetBGColor = Val(GetSetting(App.Title, "Preset", "BGColor", ""))
    PresetColor = Val(GetSetting(App.Title, "Preset", "Color", ""))
    PresetFontName = GetSetting(App.Title, "Preset", "Font", "")
    PresetFontSize = Val(GetSetting(App.Title, "Preset", "Size", "0"))
    
    If GetSetting(App.Title, "Preset", "BGColor", "") = "" Then PresetBGColor = DEFAULTBGCOLOR
    If GetSetting(App.Title, "Preset", "Color", "") = "" Then PresetColor = DEFAULTCOLOR
    If PresetFontName = "" Then PresetFontName = DEFAULTFONTNAME
    If (PresetFontSize < 6) Or (PresetFontSize > 72) Then PresetFontSize = DEFAULTFONTSIZE
    
    UsePresets = CBool(Val(GetSetting(App.Title, "Settings", "Presets", "0")))
    UseRandomBGColor = CBool(Val(GetSetting(App.Title, "Settings", "RandomBG", "0")))
        
    SaveInTheRegistry
    
    frmMain.Show
    
End Sub

Sub SaveInTheRegistry()

    SaveSetting App.Title, "Preset", "BGColor", PresetBGColor
    SaveSetting App.Title, "Preset", "Color", PresetColor
    SaveSetting App.Title, "Preset", "Font", PresetFontName
    SaveSetting App.Title, "Preset", "Size", PresetFontSize
    SaveSetting App.Title, "Settings", "Presets", IIf(UsePresets, -1, 0)
    SaveSetting App.Title, "Settings", "RandomBG", IIf(UseRandomBGColor, -1, 0)

End Sub

Function RandomBack() As Long

    Select Case Int(Rnd * 7)
    Case 0: RandomBack = BGCOLOR0
    Case 1: RandomBack = BGCOLOR1
    Case 2: RandomBack = BGCOLOR2
    Case 3: RandomBack = BGCOLOR3
    Case 4: RandomBack = BGCOLOR4
    Case 5: RandomBack = BGCOLOR5
    Case 6: RandomBack = BGCOLOR6
    Case 7: RandomBack = BGCOLOR7
    End Select
    
End Function

Function StrX(Value As Long) As String

    StrX = LTrim$(RTrim$(Str$(Value)))

End Function
